<template>
  <b-container>
    <h1>New Watch List</h1>
    <hr>
    <b-alert
      v-model="showErrorMessage"
      class="mb-2"
      dismissible
      variant="danger"
    >
      {{ errorMessage }}
    </b-alert>
    <b-form @submit.prevent="submit">
      <b-form-group label="Name">
        <b-form-input
          v-model="watchList.name"
          :disabled="submitting"
          :state="$v.watchList.name.$dirty ? ($v.watchList.name.$invalid ? false : true) : null"
          @input="$v.watchList.name.$touch"
        />
        <b-form-invalid-feedback v-if="$v.watchList.name.$dirty && !$v.watchList.name.required">
          Field is required.
        </b-form-invalid-feedback>
      </b-form-group>
      <b-form-group label="Description">
        <b-form-input
          v-model="watchList.description"
          :disabled="submitting"
          :state="$v.watchList.description.$dirty
            ? ($v.watchList.description.$invalid ? false : true)
            : null"
          @input="$v.watchList.description.$touch"
        />
        <b-form-invalid-feedback
          v-if="$v.watchList.description.$dirty && !$v.watchList.description.required"
        >
          Field is required.
        </b-form-invalid-feedback>
      </b-form-group>
      <b-form-group label="Slack Channel">
        <b-form-input
          v-model="watchList.slack_channel"
          :disabled="submitting"
          :state="$v.watchList.slack_channel.$dirty
            ? ($v.watchList.slack_channel.$invalid ? false : true)
            : null"
          @input="$v.watchList.slack_channel.$touch"
        />
        <b-form-text
          v-if="!$v.watchList.slack_channel.$dirty || !$v.watchList.slack_channel.$invalid"
        >
          You may optionally enter a Slack username or channel (e.g. #my-channel) to receive
          messages when there are hits on this watch list. We won't begin sending out these
          notifications until we've finished processing ZTF's entire history of alerts.
        </b-form-text>
        <b-form-invalid-feedback
          v-else-if="$v.watchList.slack_channel.$dirty && !$v.watchList.slack_channel.maxLength"
        >
          Field may not have more than 100 characters.
        </b-form-invalid-feedback>
      </b-form-group>
      <b-form-group label="Watched Objects File Upload">
        <b-form-file
          :state="!($v.watchList.objects.$dirty && $v.watchList.objects.$invalid)"
          @input="uploadClicked"
        />
        <b-form-text v-if="!$v.watchList.objects.$dirty || !$v.watchList.objects.$invalid">
          <p>
            Define the objects that you'd like to watch by uploading a CSV file
            here. Each row should have the form:
            <code>right_ascension,declination,radius[,comment]</code>. There
            should NOT be a header in the file. Objects in a watch list are
            subject to the following constraints:
            <ul>
              <li><code>right_ascension</code> must be between 0.0 and 360.0 degrees</li>
              <li><code>declination</code> must be between -90.0 and 90.0 degrees</li>
              <li><code>radius</code> must be less than or equal to 0.01 degree</li>
              <li><code>comment</code> is an optional description of the object</li>
            </ul>
          </p>
        </b-form-text>
        <b-form-invalid-feedback
          :force-show="$v.watchList.objects.$dirty && $v.watchList.objects.$invalid"
        >
          <p>
            Invalid CSV file. Please make sure that your file meets the
            requirements. Each row should have the form:
            <code>right_ascension,declination,radius[,comment]</code>. There
            should NOT be a header in the file. Objects in a watch list are
            subject to the following constraints:
            <ul>
              <li><code>right_ascension</code> must be between 0.0 and 360.0 degrees</li>
              <li><code>declination</code> must be between -90.0 and 90.0 degrees</li>
              <li><code>radius</code> must be less than or equal to 0.01 degree</li>
              <li><code>comment</code> is an optional description of the object</li>
            </ul>
          </p>
        </b-form-invalid-feedback>
      </b-form-group>
      <hr>
      <div style="overflow: hidden;">
        <div class="float-right">
          <b-button
            :disabled="submitting"
            :to="{ name: 'watchListList' }"
            class="mr-1"
            variant="danger"
          >
            <font-awesome-icon icon="times" />
            Cancel
          </b-button>
          <b-button
            :disabled="$v.$invalid || submitting"
            type="submit"
            variant="success"
          >
            <font-awesome-icon
              v-if="submitting"
              icon="spinner"
              pulse
            />
            <font-awesome-icon
              v-else
              icon="check"
            />
            Submit
          </b-button>
        </div>
      </div>
    </b-form>
  </b-container>
</template>

<script lang="ts">
import Vue from 'vue';
import { mapGetters } from 'vuex';
import {
  maxLength, maxValue, minValue, required,
} from 'vuelidate/lib/validators';
import Papa from 'papaparse';

import { WatchList, WatchObject } from '@/common/types';
import { WatchListService } from '@/api';

export default Vue.extend({
  data() {
    return {
      errorMessage: '',
      showErrorMessage: false,
      submitting: false,
      watchList: {
        description: '',
        id: '',
        name: '',
        objects: [] as WatchObject[],
        slack_channel: '',
      } as WatchList,
    };
  },

  computed: {
    ...mapGetters(['user']),
  },

  validations: {
    watchList: {
      description: {
        required,
      },
      name: {
        required,
      },
      objects: {
        $each: {
          declination: {
            required,
            minValue: minValue(-90.0),
            maxValue: maxValue(90.0),
          },
          radius: {
            required,
            minValue: minValue(0.0),
            maxValue: maxValue(0.01),
          },
          right_ascension: {
            required,
            minValue: minValue(0.0),
            maxValue: maxValue(360.0),
          },
        },
        required,
      },
      slack_channel: {
        maxLength: maxLength(100),
      },
    },
  },

  methods: {
    async submit(): Promise<void> {
      this.submitting = true;
      try {
        await WatchListService.create({
          owner: { id: this.user.id },
          ...this.watchList,
        });
      } catch (errors) {
        this.errorMessage = `
          There was an error creating your watch list: ${errors[0].detail}.
          Please wait a little while and try again. If you still encounter
          this issue, email ${(<any> this).ANTARES_SUPPORT_EMAIL} with a copy of your CSV
          file and we'll help you sort it out!
        `;
        this.showErrorMessage = true;
        return;
      } finally {
        this.submitting = false;
      }
      this.$router.push({
        name: 'watchListList',
      });
    },

    upload(file: File): void {
      const reader = new FileReader();
      reader.readAsText(file);
      reader.onloadend = () => {
        const { data } = Papa.parse(reader.result as string, {
          skipEmptyLines: true,
          dynamicTyping: true,
        });
        this.watchList.objects = data.map((row: unknown) => {
          const temp = <any[]>row;
          return {
            right_ascension: temp[0],
            declination: temp[1],
            radius: temp[2],
            comment: temp[3],
          };
        });
      };
    },

    uploadClicked(file: File): void {
      if (this.$v.watchList && this.$v.watchList.objects) {
        this.$v.watchList.objects.$touch();
      }
      this.upload(file);
    },
  },
});
</script>
